function TauntWatchFrame_OnLoad()

if TWConfig == nil then
	TWConfig = {
		["Reports"] = 'ON'
	}
end

SlashCmdList["TWHANDLER"] = twhandler;
	SLASH_TWHANDLER1 = "/tw"

TauntWatchFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[TauntWatch]|r v" .. GetAddOnMetadata("Alices-TauntWatch", "Version") .. " loaded. Use |cFF00FFFF/tw rep|r to disable all reports.");
TauntWatchFrame:Hide();

end

function TauntWatchFrame_OnEvent(event, ...)

if TWConfig.Reports == "OFF" then
	return
else
	local timestamp, ttype, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellid, spellname, spellschool, b_or_d = select(1, ...);
	--local TYP = tonumber(sourceGUID:sub(5,5), 16);
	--local maskedTYP = TYP % 8;
	local knownTypes = {[0]="player", [3]="NPC", [4]="pet", [5]="vehicle"};
	local lang = GetDefaultLanguage("player")
	local inInstanceGroup = IsInGroup(LE_PARTY_CATEGORY_INSTANCE)
	local inRaid = IsInRaid()

	local myName = UnitName("player")

	if (ttype == "SPELL_AURA_APPLIED") then
		-- Various taunts and threat generating abilities
		if (spellid == 355) or (spellid == 62124) or (spellid == 8056) or (spellid == 56222) or (spellid == 6795) or (spellid == 20736) then
			-- Taunt, Reckoning, Frost Shock, Dark Command, Growl and Distracting Shot
			if sourceName ~= myName and UnitInRaid(sourceName) or UnitInParty(sourceName) then
				if inInstanceGroup then
					SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on " .. destName .. ".", "INSTANCE_CHAT",lang)
				elseif IsInGroup() then
					if inRaid == true then
						SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on " .. destName .. ".", "RAID",lang)
					elseif inRaid == false then
						SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on " .. destName .. ".", "PARTY",lang)
					end
				end
			end
		elseif (spellid == 71) or (spellid == 48263) or (spellid == 25780) then
			-- Defensive Stance, Blood Presence and Righteous Fury
			if sourceName ~= myName and UnitInRaid(sourceName) or UnitInParty(sourceName) then
				if inInstanceGroup then
					SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. ".", "INSTANCE_CHAT",lang)
				elseif IsInGroup() then
					if inRaid == true then
						SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. ".", "RAID",lang)
					elseif inRaid == false then
						SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. ".", "PARTY",lang)
					end
				end
			end		
		end
	elseif (ttype == "SPELL_CAST_SUCCESS") then
		-- Death Grip
		if (spellid == 49576) then
			if sourceName ~= myName and UnitInRaid(sourceName) or UnitInParty(sourceName) then
				if inInstanceGroup then
					SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on " .. destName .. ".", "INSTANCE_CHAT",lang)
				elseif IsInGroup() then
					if inRaid == true then
						SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on " .. destName .. ".", "RAID",lang)
					elseif inRaid == false then
						SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on " .. destName .. ".", "PARTY",lang)
					end
				end
			end
		elseif (spellid == 34477) or (spellid == 57934) then
			-- Misdirection and Tricks of the Trade
			if sourceName ~= myName and UnitInRaid(sourceName) or UnitInParty(sourceName) then
				if destName == myName then
					if inInstanceGroup then
						SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on me.", "INSTANCE_CHAT",lang)
					elseif IsInGroup() then
						if inRaid == true then
							SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on me.", "RAID",lang)
						elseif inRaid == false then
							SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on me.", "PARTY",lang)
						end
					end
				elseif destName ~= myName then
					if inInstanceGroup then
						SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on " .. destName .. ".", "INSTANCE_CHAT",lang)
					elseif IsInGroup() then
						if inRaid == true then
							SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on " .. destName .. ".", "RAID",lang)
						elseif inRaid == false then
							SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on " .. destName .. ".", "PARTY",lang)
						end
					end
				end
			end
		elseif (spellid == 115546) or (spellid == 118022) then
			-- Provoke and Dizzying Haze
			if sourceName ~= myName and UnitInRaid(sourceName) or UnitInParty(sourceName) then
				if inInstanceGroup then
					SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on " .. destName .. ".", "INSTANCE_CHAT",lang)
				elseif IsInGroup() then
					if inRaid == true then
						SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on " .. destName .. ".", "RAID",lang)
					elseif inRaid == false then
						SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on " .. destName .. ".", "PARTY",lang)
					end
				end
			end
		end
	end
end

end

function twhandler(msg, editbox)

if msg == "rep" then

	if TWConfig.Reports == "ON" then
		TWConfig.Reports = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[TauntWatch]|r Reports have been turned |cFFFF0000off|r.")
	elseif TWConfig.Reports == "OFF" then
		TWConfig.Reports = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[TauntWatch]|r Reports have been turned |cFF00FF00on|r.")
	end

else
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[TauntWatch]|r Please use one of the following arguments: rep")
end

end